{ open Expr_parser 

}

let letter = [ 'a'-'z' 'A'-'Z' '0'-'9' '\'' '"' '_' '\'']
let skip = [ ' ' '\r' '\t' ',' ]
let digit = ['0'-'9']

rule eqs_token = parse
  | skip+        { eqs_token lexbuf }
  | "//"         { eqs_comment lexbuf }
  | '\n'         { NEWLINE }
  | "^{" (digit + as n) "}" 
      { POWER (int_of_string n) }
  | letter+ as s { VAR s }
  | "=?="        { DUNNO }
  | "=/="        { DIFF }
  | "<="         { LEQ }
  | "<"          { LT }
  | ">"          { GT }
  | "<>"         { IMCOMP }
  | ">="         { GEQ }
  | "="          { EGAL }
  | "^*"         { STAR }
  | "^~"         { REV }
  | '+'          { PLUS }
  | '.'          { DOT }
  | '('          { LPAR }
  | ')'          { RPAR }
  | eof          { EOF }
  | _ as s            { failwith ("lexing error"^(String.make 1 s)) }

and eqs_comment = parse
  | '\n' { NEWLINE }
  | eof  { EOF}
  | _    { eqs_comment lexbuf }
