%{
  open Regexp

  type comp = [ `Geq | `Gt | `Leq | `Lt | `Incomp | `Dunno | `Neq | `Eq ]

  let to_int n = n

  let rec expand e = function
    | 0 -> REps
    | 1 -> e
    | n -> RConc(e,expand e (n-1))
%}

%token <string> VAR 
%token <int> POWER
%token EOF NEWLINE EGAL LPAR RPAR PLUS DOT STAR REV LEQ GEQ LT GT IMCOMP DUNNO DIFF
%left PLUS
%left DOT
%nonassoc STAR REV POWER

%type <([ `Geq | `Gt | `Leq | `Lt | `Incomp | `Dunno | `Neq | `Eq ] * string Regexp.revexp * string Regexp.revexp) list> eqs
%start eqs

%%

eqs: 
| EOF                         { [] }
| NEWLINE eqs                 { $2 }
| line NEWLINE eqs            { $1::$3 }
| line EOF                    { [$1] }

line:
| regex DUNNO regex           { (`Dunno,$1,$3) }
| regex EGAL regex            { (`Eq,$1,$3) }
| regex DIFF regex            { (`Neq,$1,$3) }
| regex LEQ regex             { (`Leq,$1,$3) }
| regex GEQ regex             { (`Geq,$1,$3) }
| regex LT regex              { (`Lt,$1,$3) }
| regex GT regex              { (`Gt,$1,$3) }
| regex IMCOMP regex          { (`Incomp,$1,$3) }

regex:
| VAR                         
    { if $1="1" 
      then REps 
      else 
	if $1="0" 
	then RVide 
	else RL $1 }
| regex POWER                 { expand $1 $2 }
| regex PLUS regex            { RUnion($1,$3)}
| regex DOT regex             { RConc($1,$3)}
| regex STAR                  { REtoile $1}
| regex REV                   { Rev $1}
| LPAR regex RPAR             { $2 }
